diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/ht/ht-frame-exchange-manager.cc ns-3.38/src/wifi/model/ht/ht-frame-exchange-manager.cc
--- ns-3.37/src/wifi/model/ht/ht-frame-exchange-manager.cc	2022-11-01 17:37:24.747395800 -0700
+++ ns-3.38/src/wifi/model/ht/ht-frame-exchange-manager.cc	2023-03-16 20:54:23.856869200 -0700
@@ -67,8 +67,6 @@
 HtFrameExchangeManager::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    m_agreements.clear();
-    m_pendingAgreements.clear();
     m_pendingAddBaResp.clear();
     m_msduAggregator = nullptr;
     m_mpduAggregator = nullptr;
@@ -113,10 +111,8 @@
     {
         establish = false;
     }
-    else if (qosTxop->GetBaManager()->ExistsAgreement(recipient, tid) &&
-             !qosTxop->GetBaManager()->ExistsAgreementInState(recipient,
-                                                              tid,
-                                                              OriginatorBlockAckAgreement::RESET))
+    else if (auto agreement = qosTxop->GetBaManager()->GetAgreementAsOriginator(recipient, tid);
+             agreement && !agreement->get().IsReset())
     {
         establish = false;
     }
@@ -147,7 +143,9 @@
 
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_MGT_ACTION);
-    hdr.SetAddr1(dest);
+    // use the remote link address if dest is an MLD address
+    auto addr1 = GetWifiRemoteStationManager()->GetAffiliatedStaAddress(dest);
+    hdr.SetAddr1(addr1 ? *addr1 : dest);
     hdr.SetAddr2(m_self);
     hdr.SetAddr3(m_bssid);
     hdr.SetDsNotTo();
@@ -179,7 +177,7 @@
     // set the starting sequence number for the BA agreement
     reqHdr.SetStartingSequence(startingSeq);
 
-    GetBaManager(tid)->CreateAgreement(&reqHdr, dest);
+    GetBaManager(tid)->CreateOriginatorAgreement(reqHdr, dest);
 
     packet->AddHeader(reqHdr);
     packet->AddHeader(actionHdr);
@@ -229,7 +227,8 @@
     {
         respHdr.SetDelayedBlockAck();
     }
-    respHdr.SetTid(reqHdr->GetTid());
+    auto tid = reqHdr->GetTid();
+    respHdr.SetTid(tid);
 
     respHdr.SetBufferSize(GetSupportedBaBufferSize());
     respHdr.SetTimeout(reqHdr->GetTimeout());
@@ -243,7 +242,33 @@
     packet->AddHeader(respHdr);
     packet->AddHeader(actionHdr);
 
-    CreateBlockAckAgreement(&respHdr, originator, reqHdr->GetStartingSequence());
+    // Get the MLD address of the originator, if an ML setup was performed
+    if (auto originatorMld = GetWifiRemoteStationManager()->GetMldAddress(originator))
+    {
+        originator = *originatorMld;
+    }
+    bool htSupported = GetWifiRemoteStationManager()->GetHtSupported() &&
+                       GetWifiRemoteStationManager()->GetHtSupported(originator);
+    GetBaManager(tid)->CreateRecipientAgreement(respHdr,
+                                                originator,
+                                                reqHdr->GetStartingSequence(),
+                                                htSupported,
+                                                m_rxMiddle);
+
+    auto agreement = GetBaManager(tid)->GetAgreementAsRecipient(originator, tid);
+    NS_ASSERT(agreement);
+    if (respHdr.GetTimeout() != 0)
+    {
+        Time timeout = MicroSeconds(1024 * agreement->get().GetTimeout());
+
+        agreement->get().m_inactivityEvent =
+            Simulator::Schedule(timeout,
+                                &HtFrameExchangeManager::SendDelbaFrame,
+                                this,
+                                originator,
+                                tid,
+                                false);
+    }
 
     auto mpdu = Create<WifiMpdu>(packet, hdr);
 
@@ -253,15 +278,12 @@
      * an ADDBA_RESPONSE frame, but is not able to successfully transmit it before the timer to
      * wait for ADDBA_RESPONSE expires at the originator. The latter may then send another
      * ADDBA_REQUEST frame, which triggers the creation of another ADDBA_RESPONSE frame.
-     * The first ADDBA_RESPONSE frame that is acknowledged causes the Block Ack agreement to be
-     * moved from the queue of pending agreements to the queue of establish agreements; the next
-     * one will find no pending agreement, thus causing the simulation to abort.
-     * As a solution, we keep track of the previously enqueued ADDBA_RESPONSE frame (if any),
-     * dequeue it and replace it with the new ADDBA_RESPONSE frame.
+     * To avoid sending unnecessary ADDBA_RESPONSE frames, we keep track of the previously enqueued
+     * ADDBA_RESPONSE frame (if any), dequeue it and replace it with the new ADDBA_RESPONSE frame.
      */
 
     // remove any pending ADDBA_RESPONSE frame
-    AgreementKey key(originator, reqHdr->GetTid());
+    AgreementKey key(originator, tid);
     if (auto it = m_pendingAddBaResp.find(key); it != m_pendingAddBaResp.end())
     {
         NS_ASSERT_MSG(it->second, "The pointer to the pending ADDBA_RESPONSE cannot be null");
@@ -275,7 +297,7 @@
     // bung it into the queue corresponding to the TID for which we are
     // establishing an agreement, and push it to the head.
     //  Wifi MAC queue scheduler is expected to prioritize management frames
-    m_mac->GetQosTxop(reqHdr->GetTid())->Queue(mpdu);
+    m_mac->GetQosTxop(tid)->Queue(mpdu);
 }
 
 uint16_t
@@ -290,7 +312,8 @@
     NS_LOG_FUNCTION(this << addr << +tid << byOriginator);
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_MGT_ACTION);
-    hdr.SetAddr1(addr);
+    // use the remote link address if addr is an MLD address
+    hdr.SetAddr1(GetWifiRemoteStationManager()->GetAffiliatedStaAddress(addr).value_or(addr));
     hdr.SetAddr2(m_self);
     hdr.SetAddr3(m_bssid);
     hdr.SetDsNotTo();
@@ -301,12 +324,12 @@
     if (byOriginator)
     {
         delbaHdr.SetByOriginator();
-        GetBaManager(tid)->DestroyAgreement(addr, tid);
+        GetBaManager(tid)->DestroyOriginatorAgreement(addr, tid);
     }
     else
     {
         delbaHdr.SetByRecipient();
-        DestroyBlockAckAgreement(addr, tid);
+        GetBaManager(tid)->DestroyRecipientAgreement(addr, tid);
     }
 
     WifiActionHeader actionHdr;
@@ -321,69 +344,14 @@
     m_mac->GetQosTxop(tid)->GetWifiMacQueue()->Enqueue(Create<WifiMpdu>(packet, hdr));
 }
 
-void
-HtFrameExchangeManager::CreateBlockAckAgreement(const MgtAddBaResponseHeader* respHdr,
-                                                Mac48Address originator,
-                                                uint16_t startingSeq)
-{
-    NS_LOG_FUNCTION(this << *respHdr << originator << startingSeq);
-    uint8_t tid = respHdr->GetTid();
-
-    RecipientBlockAckAgreement agreement(
-        originator,
-        respHdr->IsAmsduSupported(),
-        tid,
-        respHdr->GetBufferSize(),
-        respHdr->GetTimeout(),
-        startingSeq,
-        GetWifiRemoteStationManager()->GetHtSupported() &&
-            GetWifiRemoteStationManager()->GetHtSupported(originator));
-    agreement.SetMacRxMiddle(m_rxMiddle);
-    if (respHdr->IsImmediateBlockAck())
-    {
-        agreement.SetImmediateBlockAck();
-    }
-    else
-    {
-        agreement.SetDelayedBlockAck();
-    }
-
-    if (respHdr->GetTimeout() != 0)
-    {
-        Time timeout = MicroSeconds(1024 * agreement.GetTimeout());
-
-        agreement.m_inactivityEvent = Simulator::Schedule(timeout,
-                                                          &HtFrameExchangeManager::SendDelbaFrame,
-                                                          this,
-                                                          originator,
-                                                          tid,
-                                                          false);
-    }
-
-    m_pendingAgreements.insert_or_assign({originator, tid}, agreement);
-}
-
-void
-HtFrameExchangeManager::DestroyBlockAckAgreement(Mac48Address originator, uint8_t tid)
-{
-    NS_LOG_FUNCTION(this << originator << +tid);
-
-    auto agreementIt = m_agreements.find({originator, tid});
-    if (agreementIt != m_agreements.end())
-    {
-        // forward up the buffered MPDUs before destroying the agreement
-        agreementIt->second.Flush();
-        m_agreements.erase(agreementIt);
-    }
-}
-
 bool
 HtFrameExchangeManager::StartFrameExchange(Ptr<QosTxop> edca, Time availableTime, bool initialFrame)
 {
     NS_LOG_FUNCTION(this << edca << availableTime << initialFrame);
 
     // First, check if there is a BAR to be transmitted
-    if (SendMpduFromBaManager(edca, availableTime, initialFrame))
+    if (auto mpdu = GetBar(edca->GetAccessCategory());
+        mpdu && SendMpduFromBaManager(mpdu, availableTime, initialFrame))
     {
         return true;
     }
@@ -421,7 +389,8 @@
 
     // Use SendDataFrame if we can try aggregation
     if (hdr.IsQosData() && !hdr.GetAddr1().IsGroup() && !peekedItem->IsFragment() &&
-        !GetWifiRemoteStationManager()->NeedFragmentation(peekedItem))
+        !GetWifiRemoteStationManager()->NeedFragmentation(peekedItem =
+                                                              CreateAliasIfNeeded(peekedItem)))
     {
         return SendDataFrame(peekedItem, availableTime, initialFrame);
     }
@@ -434,33 +403,182 @@
     return QosFrameExchangeManager::StartFrameExchange(edca, availableTime, initialFrame);
 }
 
+Ptr<WifiMpdu>
+HtFrameExchangeManager::GetBar(AcIndex ac,
+                               std::optional<uint8_t> optTid,
+                               std::optional<Mac48Address> optAddress)
+{
+    NS_LOG_FUNCTION(this << +ac << optTid.has_value() << optAddress.has_value());
+    NS_ASSERT_MSG(optTid.has_value() == optAddress.has_value(),
+                  "Either both or none of TID and address must be provided");
+
+    // remove all expired MPDUs from the MAC queue, so that
+    // BlockAckRequest frames (if needed) are scheduled
+    auto queue = m_mac->GetTxopQueue(ac);
+    queue->WipeAllExpiredMpdus();
+
+    // in case of MLD, we need to check both the queue of control frames that need to be sent
+    // on our link and the queue of control frames that can be sent on any link. We start with
+    // the former, but we check the latter even if a suitable frame is found in the former
+    // (because a BAR that can be sent on any link to a recipient is no longer needed after
+    // sending a BAR to that recipient on our link).
+
+    std::list<WifiContainerQueueId> queueIds{{WIFI_CTL_QUEUE, m_self, std::nullopt}};
+    if (m_self != m_mac->GetAddress())
+    {
+        // add the MLD address
+        queueIds.emplace_back(WIFI_CTL_QUEUE, m_mac->GetAddress(), std::nullopt);
+    }
+    Ptr<WifiMpdu> selectedBar;
+    uint8_t selectedTid = 0;
+
+    for (const auto& queueId : queueIds)
+    {
+        Ptr<WifiMpdu> bar;
+        Ptr<WifiMpdu> prevBar;
+
+        while ((bar = queue->PeekByQueueId(queueId, prevBar)))
+        {
+            if (bar->GetHeader().IsBlockAckReq())
+            {
+                CtrlBAckRequestHeader reqHdr;
+                bar->GetPacket()->PeekHeader(reqHdr);
+                auto tid = reqHdr.GetTidInfo();
+                Mac48Address recipient = bar->GetHeader().GetAddr1();
+
+                if (selectedBar)
+                {
+                    NS_ASSERT_MSG(std::get<Mac48Address>(queueId) != m_self,
+                                  "We shall not keep iterating over the control frames that need"
+                                  "to be sent on a specific link after selecting a BAR to send");
+                    // if this BlockAckReq is addressed to the same recipient as the selected BAR,
+                    // remove it from the queue and stop iterating over this queue; otherwise,
+                    // move on to the next frame in the queue
+                    if (GetWifiRemoteStationManager()->GetAffiliatedStaAddress(recipient) ==
+                            selectedBar->GetHeader().GetAddr1() &&
+                        selectedTid == tid)
+                    {
+                        queue->Remove(bar);
+                        break;
+                    }
+                    prevBar = bar;
+                    continue;
+                }
+
+                // if this BlockAckReq can be sent on any link, we have to check that this link
+                // has been setup with the recipient (this may happen, e.g., if we are an AP MLD
+                // and we have setup a subset of our links with a non-AP MLD)
+                if (bar->GetHeader().GetAddr2() != m_self && m_mac->GetMldAddress(recipient) &&
+                    !GetWifiRemoteStationManager()->GetAffiliatedStaAddress(recipient))
+                {
+                    prevBar = bar;
+                    continue;
+                }
+
+                if (optAddress &&
+                    (GetWifiRemoteStationManager()
+                             ->GetMldAddress(*optAddress)
+                             .value_or(*optAddress) !=
+                         GetWifiRemoteStationManager()->GetMldAddress(recipient).value_or(
+                             recipient) ||
+                     optTid != tid))
+                {
+                    NS_LOG_DEBUG("BAR " << *bar
+                                        << " cannot be returned because it is not addressed"
+                                           " to the given station for the given TID");
+                    prevBar = bar;
+                    continue;
+                }
+
+                auto agreement = m_mac->GetBaAgreementEstablishedAsOriginator(recipient, tid);
+                if (!agreement)
+                {
+                    NS_LOG_DEBUG("BA agreement with " << recipient << " for TID=" << +tid
+                                                      << " was torn down");
+                    queue->Remove(bar);
+                    continue;
+                }
+                // update BAR if the starting sequence number changed
+                if (auto seqNo = agreement->get().GetStartingSequence();
+                    reqHdr.GetStartingSequence() != seqNo)
+                {
+                    reqHdr.SetStartingSequence(seqNo);
+                    Ptr<Packet> packet = Create<Packet>();
+                    packet->AddHeader(reqHdr);
+                    auto updatedBar = Create<WifiMpdu>(packet, bar->GetHeader());
+                    queue->Replace(bar, updatedBar);
+                    bar = updatedBar;
+                }
+                // bar is the BlockAckReq to send
+                selectedBar = bar;
+                selectedTid = tid;
+                break;
+            }
+            if (bar->GetHeader().IsTrigger() && !optAddress && !selectedBar)
+            {
+                return bar;
+            }
+            // not a BAR nor a Trigger Frame, continue
+            prevBar = bar;
+        }
+    }
+
+    if (!selectedBar)
+    {
+        // check if we can send a BAR to a recipient to which a BAR can only be sent if data queued
+        auto baManager = m_mac->GetQosTxop(ac)->GetBaManager();
+        for (const auto& [recipient, tid] : baManager->GetSendBarIfDataQueuedList())
+        {
+            if (queue->PeekByTidAndAddress(tid, recipient))
+            {
+                selectedBar = m_mac->GetQosTxop(ac)->PrepareBlockAckRequest(recipient, tid);
+                baManager->RemoveFromSendBarIfDataQueuedList(recipient, tid);
+                queue->Enqueue(selectedBar);
+                break;
+            }
+        }
+    }
+
+    if (selectedBar && selectedBar->GetHeader().GetAddr2() != m_self)
+    {
+        // the selected BAR has MLD addresses in Addr1/Addr2, replace them with link addresses
+        // and move to the appropriate container queue
+        NS_ASSERT(selectedBar->GetHeader().GetAddr2() == m_mac->GetAddress());
+        DequeueMpdu(selectedBar);
+        const auto currAddr1 = selectedBar->GetHeader().GetAddr1();
+        auto addr1 =
+            GetWifiRemoteStationManager()->GetAffiliatedStaAddress(currAddr1).value_or(currAddr1);
+        selectedBar->GetHeader().SetAddr1(addr1);
+        selectedBar->GetHeader().SetAddr2(m_self);
+        queue->Enqueue(selectedBar);
+    }
+
+    return selectedBar;
+}
+
 bool
-HtFrameExchangeManager::SendMpduFromBaManager(Ptr<QosTxop> edca,
+HtFrameExchangeManager::SendMpduFromBaManager(Ptr<WifiMpdu> mpdu,
                                               Time availableTime,
                                               bool initialFrame)
 {
-    NS_LOG_FUNCTION(this << edca << availableTime << initialFrame);
+    NS_LOG_FUNCTION(this << *mpdu << availableTime << initialFrame);
 
     // First, check if there is a BAR to be transmitted
-    Ptr<const WifiMpdu> peekedItem = edca->GetBaManager()->GetBar(false);
-
-    if (!peekedItem)
+    if (!mpdu->GetHeader().IsBlockAckReq())
     {
         NS_LOG_DEBUG("Block Ack Manager returned no frame to send");
         return false;
     }
 
-    NS_ASSERT(peekedItem->GetHeader().IsBlockAckReq());
-
     // Prepare the TX parameters. Note that the default ack manager expects the
     // data TxVector in the m_txVector field to compute the BlockAck TxVector.
     // The m_txVector field of the TX parameters is set to the BlockAckReq TxVector
     // a few lines below.
     WifiTxParameters txParams;
     txParams.m_txVector =
-        GetWifiRemoteStationManager()->GetDataTxVector(peekedItem->GetHeader(), m_allowedWidth);
+        GetWifiRemoteStationManager()->GetDataTxVector(mpdu->GetHeader(), m_allowedWidth);
     txParams.m_protection = std::unique_ptr<WifiProtection>(new WifiNoProtection);
-    txParams.m_acknowledgment = GetAckManager()->TryAddMpdu(peekedItem, txParams);
+    txParams.m_acknowledgment = GetAckManager()->TryAddMpdu(mpdu, txParams);
 
     NS_ABORT_IF(txParams.m_acknowledgment->method != WifiAcknowledgment::BLOCK_ACK);
 
@@ -469,7 +587,7 @@
     // the BlockAckReq frame is sent using the same TXVECTOR as the BlockAck frame
     txParams.m_txVector = blockAcknowledgment->blockAckTxVector;
 
-    Time barTxDuration = m_phy->CalculateTxDuration(peekedItem->GetSize(),
+    Time barTxDuration = m_phy->CalculateTxDuration(mpdu->GetSize(),
                                                     blockAcknowledgment->blockAckTxVector,
                                                     m_phy->GetPhyBand());
 
@@ -484,8 +602,7 @@
     }
 
     // we can transmit the BlockAckReq frame
-    Ptr<const WifiMpdu> mpdu = edca->GetBaManager()->GetBar();
-    SendPsduWithProtection(GetWifiPsdu(Copy(mpdu), txParams.m_txVector), txParams);
+    SendPsduWithProtection(GetWifiPsdu(mpdu, txParams.m_txVector), txParams);
     return true;
 }
 
@@ -592,14 +709,16 @@
         uint8_t tid = mpdu->GetHeader().GetQosTid();
         Ptr<QosTxop> edca = m_mac->GetQosTxop(tid);
 
-        if (edca->GetBaAgreementEstablished(mpdu->GetHeader().GetAddr1(), tid))
+        if (m_mac->GetBaAgreementEstablishedAsOriginator(mpdu->GetHeader().GetAddr1(), tid))
         {
             // notify the BA manager that the MPDU was acknowledged
-            edca->GetBaManager()->NotifyGotAck(mpdu);
+            edca->GetBaManager()->NotifyGotAck(m_linkId, mpdu);
         }
     }
     else if (mpdu->GetHeader().IsAction())
     {
+        auto addr1 = mpdu->GetHeader().GetAddr1();
+        auto address = GetWifiRemoteStationManager()->GetMldAddress(addr1).value_or(addr1);
         WifiActionHeader actionHdr;
         Ptr<Packet> p = mpdu->GetPacket()->Copy();
         p->RemoveHeader(actionHdr);
@@ -609,14 +728,14 @@
             {
                 MgtDelBaHeader delBa;
                 p->PeekHeader(delBa);
+                auto tid = delBa.GetTid();
                 if (delBa.IsByOriginator())
                 {
-                    GetBaManager(delBa.GetTid())
-                        ->DestroyAgreement(mpdu->GetHeader().GetAddr1(), delBa.GetTid());
+                    GetBaManager(tid)->DestroyOriginatorAgreement(address, tid);
                 }
                 else
                 {
-                    DestroyBlockAckAgreement(mpdu->GetHeader().GetAddr1(), delBa.GetTid());
+                    GetBaManager(tid)->DestroyRecipientAgreement(address, tid);
                 }
             }
             else if (actionHdr.GetAction().blockAck == WifiActionHeader::BLOCK_ACK_ADDBA_REQUEST)
@@ -628,23 +747,19 @@
                 Simulator::Schedule(edca->GetAddBaResponseTimeout(),
                                     &QosTxop::AddBaResponseTimeout,
                                     edca,
-                                    mpdu->GetHeader().GetAddr1(),
+                                    address,
                                     addBa.GetTid());
             }
             else if (actionHdr.GetAction().blockAck == WifiActionHeader::BLOCK_ACK_ADDBA_RESPONSE)
             {
-                // The recipient Block Ack agreement can be moved from the pending queue
-                // to the queue of established Block Ack agreements
+                // A recipient Block Ack agreement must exist
                 MgtAddBaResponseHeader addBa;
                 p->PeekHeader(addBa);
-                AgreementKey key(mpdu->GetHeader().GetAddr1(), addBa.GetTid());
-                auto nh = m_pendingAgreements.extract(key);
-                NS_ASSERT_MSG(!nh.empty(),
-                              "Pending agreement {" << key.first << ", " << +key.second
-                                                    << "} not found");
-                m_agreements.erase(nh.key());
-                m_agreements.insert(std::move(nh));
-                m_pendingAddBaResp.erase(key);
+                auto tid = addBa.GetTid();
+                NS_ASSERT_MSG(GetBaManager(tid)->GetAgreementAsRecipient(address, tid),
+                              "Recipient BA agreement {" << address << ", " << +tid
+                                                         << "} not found");
+                m_pendingAddBaResp.erase({address, tid});
             }
         }
     }
@@ -656,7 +771,7 @@
 {
     NS_LOG_DEBUG(this);
 
-    if (m_edca && m_edca->GetTxopLimit(m_linkId).IsZero() && m_edca->GetBaManager()->GetBar(false))
+    if (m_edca && m_edca->GetTxopLimit(m_linkId).IsZero() && GetBar(m_edca->GetAccessCategory()))
     {
         // A TXOP limit of 0 indicates that the TXOP holder may transmit or cause to
         // be transmitted (as responses) the following within the current TXOP:
@@ -688,20 +803,26 @@
     {
         WifiActionHeader actionHdr;
         mpdu->GetPacket()->PeekHeader(actionHdr);
-        if (actionHdr.GetCategory() == WifiActionHeader::BLOCK_ACK)
+        if (actionHdr.GetCategory() == WifiActionHeader::BLOCK_ACK &&
+            actionHdr.GetAction().blockAck == WifiActionHeader::BLOCK_ACK_ADDBA_REQUEST)
         {
             uint8_t tid = GetTid(mpdu->GetPacket(), mpdu->GetHeader());
-            if (GetBaManager(tid)->ExistsAgreementInState(mpdu->GetHeader().GetAddr1(),
-                                                          tid,
-                                                          OriginatorBlockAckAgreement::PENDING))
+            auto recipient = mpdu->GetHeader().GetAddr1();
+            // if the recipient is an MLD, use its MLD address
+            if (auto mldAddr = GetWifiRemoteStationManager()->GetMldAddress(recipient))
+            {
+                recipient = *mldAddr;
+            }
+            if (auto agreement = GetBaManager(tid)->GetAgreementAsOriginator(recipient, tid);
+                agreement && agreement->get().IsPending())
             {
                 NS_LOG_DEBUG("No ACK after ADDBA request");
-                GetBaManager(tid)->NotifyAgreementNoReply(mpdu->GetHeader().GetAddr1(), tid);
                 Ptr<QosTxop> qosTxop = m_mac->GetQosTxop(tid);
+                qosTxop->NotifyOriginatorAgreementNoReply(recipient, tid);
                 Simulator::Schedule(qosTxop->GetFailedAddBaTimeout(),
                                     &QosTxop::ResetBa,
                                     qosTxop,
-                                    mpdu->GetHeader().GetAddr1(),
+                                    recipient,
                                     tid);
             }
         }
@@ -719,10 +840,10 @@
         uint8_t tid = mpdu->GetHeader().GetQosTid();
         Ptr<QosTxop> edca = m_mac->GetQosTxop(tid);
 
-        if (edca->GetBaAgreementEstablished(mpdu->GetHeader().GetAddr1(), tid))
+        if (m_mac->GetBaAgreementEstablishedAsOriginator(mpdu->GetHeader().GetAddr1(), tid))
         {
             // notify the BA manager that the MPDU was not acknowledged
-            edca->GetBaManager()->NotifyMissedAck(mpdu);
+            edca->GetBaManager()->NotifyMissedAck(m_linkId, mpdu);
             return;
         }
     }
@@ -730,35 +851,53 @@
 }
 
 void
-HtFrameExchangeManager::ReleaseSequenceNumber(Ptr<WifiMpdu> mpdu) const
+HtFrameExchangeManager::ReleaseSequenceNumbers(Ptr<const WifiPsdu> psdu) const
 {
-    NS_LOG_FUNCTION(this << *mpdu);
+    NS_LOG_FUNCTION(this << *psdu);
 
-    // the MPDU should be still in the queue, unless it expired.
-    const WifiMacHeader& hdr = mpdu->GetHeader();
-    if (hdr.IsQosData())
+    auto tids = psdu->GetTids();
+
+    if (tids.empty() || // no QoS data frames included
+        !m_mac->GetBaAgreementEstablishedAsOriginator(psdu->GetAddr1(), *tids.begin()))
     {
-        uint8_t tid = hdr.GetQosTid();
-        Ptr<QosTxop> edca = m_mac->GetQosTxop(tid);
+        QosFrameExchangeManager::ReleaseSequenceNumbers(psdu);
+        return;
+    }
+
+    // iterate over MPDUs in reverse order (to process them in decreasing order of sequence number)
+    auto mpduIt = psdu->end();
+
+    do
+    {
+        std::advance(mpduIt, -1);
 
-        if (edca->GetBaAgreementEstablished(hdr.GetAddr1(), tid) && !hdr.IsRetry())
+        const WifiMacHeader& hdr = (*mpduIt)->GetOriginal()->GetHeader();
+        if (hdr.IsQosData())
         {
-            // The MPDU has never been transmitted, so we can make its sequence
-            // number available again if it is lower than the sequence number
-            // maintained by the MAC TX middle
-            uint16_t currentNextSeq = m_txMiddle->PeekNextSequenceNumberFor(&hdr);
-            uint16_t startingSeq = edca->GetBaStartingSequence(hdr.GetAddr1(), tid);
+            uint8_t tid = hdr.GetQosTid();
+            NS_ASSERT(m_mac->GetBaAgreementEstablishedAsOriginator(hdr.GetAddr1(), tid));
 
-            if (BlockAckAgreement::GetDistance(hdr.GetSequenceNumber(), startingSeq) <
-                BlockAckAgreement::GetDistance(currentNextSeq, startingSeq))
+            if (!hdr.IsRetry() && !(*mpduIt)->IsInFlight())
             {
-                m_txMiddle->SetSequenceNumberFor(&hdr);
-            }
+                // The MPDU has never been transmitted, so we can make its sequence
+                // number available again if it is the highest sequence number
+                // assigned by the MAC TX middle
+                uint16_t currentNextSeq = m_txMiddle->PeekNextSequenceNumberFor(&hdr);
 
-            return;
+                if ((hdr.GetSequenceNumber() + 1) % SEQNO_SPACE_SIZE == currentNextSeq)
+                {
+                    (*mpduIt)->UnassignSeqNo();
+                    m_txMiddle->SetSequenceNumberFor(&hdr);
+
+                    NS_LOG_DEBUG("Released " << hdr.GetSequenceNumber()
+                                             << ", next sequence "
+                                                "number for dest="
+                                             << hdr.GetAddr1() << ",tid=" << +tid << " is "
+                                             << m_txMiddle->PeekNextSequenceNumberFor(&hdr));
+                }
+            }
         }
-    }
-    QosFrameExchangeManager::ReleaseSequenceNumber(mpdu);
+    } while (mpduIt != psdu->begin());
 }
 
 Time
@@ -814,6 +953,14 @@
     // Set QoS Ack policy
     WifiAckManager::SetQosAckPolicy(m_psdu, m_txParams.m_acknowledgment.get());
 
+    for (const auto& mpdu : *PeekPointer(m_psdu))
+    {
+        if (mpdu->IsQueued())
+        {
+            mpdu->SetInFlight(m_linkId);
+        }
+    }
+
     if (m_txParams.m_protection->method == WifiProtection::RTS_CTS)
     {
         SendRts(m_txParams);
@@ -866,7 +1013,7 @@
         std::set<uint8_t> tids = m_psdu->GetTids();
         NS_ASSERT_MSG(tids.size() <= 1, "Multi-TID A-MPDUs are not supported");
 
-        if (tids.size() == 0 || m_psdu->GetAckPolicyForTid(*tids.begin()) == WifiMacHeader::NO_ACK)
+        if (tids.empty() || m_psdu->GetAckPolicyForTid(*tids.begin()) == WifiMacHeader::NO_ACK)
         {
             // No acknowledgment, hence dequeue the PSDU if it is stored in a queue
             DequeuePsdu(m_psdu);
@@ -905,7 +1052,7 @@
         uint8_t tid = *tids.begin();
 
         Ptr<QosTxop> edca = m_mac->GetQosTxop(tid);
-        edca->ScheduleBar(edca->PrepareBlockAckRequest(m_psdu->GetAddr1(), tid));
+        GetBaManager(tid)->ScheduleBar(edca->PrepareBlockAckRequest(m_psdu->GetAddr1(), tid));
 
         Simulator::Schedule(txDuration, &HtFrameExchangeManager::TransmissionSucceeded, this);
     }
@@ -1217,7 +1364,8 @@
 {
     NS_LOG_FUNCTION(this << psdu << txVector << resetCw);
 
-    Mac48Address recipient = psdu->GetAddr1();
+    auto recipient = psdu->GetAddr1();
+    auto recipientMld = GetWifiRemoteStationManager()->GetMldAddress(recipient).value_or(recipient);
     bool isBar;
     uint8_t tid;
 
@@ -1244,18 +1392,27 @@
     if (edca->UseExplicitBarAfterMissedBlockAck() || isBar)
     {
         // we have to send a BlockAckReq, if needed
-        if (GetBaManager(tid)->NeedBarRetransmission(tid, recipient))
+        if (GetBaManager(tid)->NeedBarRetransmission(tid, recipientMld))
         {
             NS_LOG_DEBUG("Missed Block Ack, transmit a BlockAckReq");
+            /**
+             * The BlockAckReq must be sent on the same link as the data frames to avoid issues.
+             * As an example, assume that an A-MPDU is sent on link 0, the BlockAck timer
+             * expires and the BlockAckReq is sent on another link (e.g., on link 1). When the
+             * originator processes the BlockAck response, it will not interpret a '0' in the
+             * bitmap corresponding to the transmitted MPDUs as a negative acknowledgment,
+             * because the BlockAck is received on a different link than the one on which the
+             * MPDUs are (still) inflight. Hence, such MPDUs stay inflight and are not
+             * retransmitted.
+             */
             if (isBar)
             {
                 psdu->GetHeader(0).SetRetry();
-                edca->ScheduleBar(*psdu->begin());
             }
             else
             {
                 // missed block ack after data frame with Implicit BAR Ack policy
-                edca->ScheduleBar(edca->PrepareBlockAckRequest(recipient, tid));
+                GetBaManager(tid)->ScheduleBar(edca->PrepareBlockAckRequest(recipient, tid));
             }
             resetCw = false;
         }
